'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Script = undefined;

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _asset = require('./asset');

var _asset2 = _interopRequireDefault(_asset);

var _docblock = require('../utils/docblock');

var _docblock2 = _interopRequireDefault(_docblock);

var _babel = require('./parsers/babel');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var EXTENSIONS = ['js', 'jsx', 'cjsx', 'coffee', 'es6'];
var GLOB = '**/*.{' + EXTENSIONS.join(',') + '}';

// can parse, index, transform js with babel

var Script = exports.Script = (function (_Asset) {
  (0, _inherits3.default)(Script, _Asset);

  function Script(uri) {
    var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];
    (0, _classCallCheck3.default)(this, Script);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Script).call(this, uri, options));

    _this.transformer = function (val) {
      return val.code;
    };
    _this.indexer = function (val) {
      return val;
    };
    _this.parser = function () {
      return _babel.transform.apply(undefined, arguments);
    };
    return _this;
  }

  (0, _createClass3.default)(Script, [{
    key: 'getData',
    value: function getData() {
      if (!this.raw || this.raw.length === 0) {
        this.runImporter('disk', { asset: this, sync: true });
      }

      return this.frontmatter || {};
    }
  }, {
    key: 'generateId',
    value: function generateId() {
      var base = '' + this.paths.relative.replace(this.extension, '');

      if (base.match(/\/index$/)) {
        base = base.replace(/\/index$/, '');
      }

      return base;
    }
  }, {
    key: 'frontmatter',
    get: function get() {
      try {
        return _docblock2.default.parse(this.raw);
      } catch (error) {
        return {};
      }
    }
  }]);
  return Script;
})(_asset2.default);

Script.EXTENSIONS = EXTENSIONS;
Script.GLOB = GLOB;
exports.default = Script;